## bppsuite 2.4.1

=== CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Authors:
#   Julien Dutheil
#   Francois Gindraud (2017)
# Created: 22/08/2009

cmake_minimum_required (VERSION 2.8.11)
project (bppsuite CXX)

# Compile options
SET (CMAKE_CXX_FLAGS "-std=c++11 -Wall -Weffc++ -Wshadow -Wconversion")

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF(NOT NO_DEP_CHECK)
  SET(NO_DEP_CHECK FALSE CACHE BOOL
      "Disable dependencies check for building distribution only."
      FORCE)
ENDIF(NOT NO_DEP_CHECK)

IF(NO_DEP_CHECK)
  MESSAGE(STATUS "Dependencies checking disabled. Only distribution can be built.")
ELSE(NO_DEP_CHECK)


#static linkage?
IF(NOT BUILD_STATIC)
  SET(BUILD_STATIC FALSE CACHE BOOL
      "Enable static linkage."
      FORCE)
ENDIF()
IF(BUILD_STATIC)
  MESSAGE(STATUS "Static linkage requested.")
  SET(CMAKE_CXX_FLAGS "-static -static-libgcc ${CMAKE_CXX_FLAGS}")
ENDIF()

# Check compression program
# COMPRESS_PROGRAM controls the choice of program
# COMPRESS_EXT can be used to override the file extension
if (NOT COMPRESS_PROGRAM)
  set (COMPRESS_PROGRAM gzip CACHE STRING "Set program for compressing documentation" FORCE)
endif ()
find_program (COMPRESS_BIN NAMES ${COMPRESS_PROGRAM} DOC "${COMPRESS_PROGRAM} compression program")
if (NOT COMPRESS_BIN)
  message (STATUS "${COMPRESS_PROGRAM} program not found, text doc will not be compressed")
else ()
  # Deduce COMPRESS_EXT for known compression programs if not set
  if (NOT COMPRESS_EXT)
    if (${COMPRESS_PROGRAM} STREQUAL "gzip")
      set (COMPRESS_EXT "gz")
    elseif (${COMPRESS_PROGRAM} STREQUAL "bzip2")
      set (COMPRESS_EXT "bz2")
    else ()
      set (COMPRESS_EXT "${COMPRESS_PROGRAM}") # Default: program name (works for xz/lzma)
    endif ()
  endif ()
  # Generate command line args (always add -c to output compressed file to stdout)
  if (${COMPRESS_PROGRAM} STREQUAL "gzip")
    # -n for no timestamp in files (reproducible builds)
    # -9 for maximum compression (lintian error)
    set (COMPRESS_ARGS -c -n -9)
  else ()
    set (COMPRESS_ARGS -c)
  endif ()
  message (STATUS "Found ${COMPRESS_BIN} compression program, using file extension .${COMPRESS_EXT}")
endif ()

# Find dependencies (add install directory to search)
if (CMAKE_INSTALL_PREFIX)
  set (CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
endif (CMAKE_INSTALL_PREFIX)

include (GNUInstallDirs)
find_package (bpp-phyl 12.0.0 REQUIRED)
find_package (bpp-popgen 8.0.0 REQUIRED)

# Subdirectories
add_subdirectory (bppSuite)
add_subdirectory (doc)
add_subdirectory (man)

ENDIF(NO_DEP_CHECK)

# Packager
SET(CPACK_PACKAGE_NAME "bppsuite")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "2.4.1")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "4")
SET(CPACK_PACKAGE_VERSION_PATCH "1")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL.txt")
SET(CPACK_SOURCE_GENERATOR "TGZ")
# /!\ This assumes that an external build is used
SET(CPACK_SOURCE_IGNORE_FILES 
       "/build/" 
       "/\\\\.git/" 
       "/\\\\.gitignore" 
       ${CPACK_SOURCE_IGNORE_FILES}
       )

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF(NOT NO_DEP_CHECK)
IF (UNIX)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist info man)

#ADD_DEPENDENCIES(info install)

ENDIF(UNIX)

ENDIF(NOT NO_DEP_CHECK)

=== bppSuite/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Authors:
#   Julien Dutheil
#   Francois Gindraud (2017)
# Created: 22/08/2009

# Executables of bppsuite.
# Generation of targets from file name is not automated in case of executables not following the pattern.
add_executable (bppml bppML.cpp)
add_executable (bppseqgen bppSeqGen.cpp)
add_executable (bppdist bppDist.cpp)
add_executable (bpppars bppPars.cpp)
add_executable (bppseqman bppSeqMan.cpp)
add_executable (bppconsense bppConsense.cpp)
add_executable (bppancestor bppAncestor.cpp)
add_executable (bppmixedlikelihoods bppMixedLikelihoods.cpp)
add_executable (bppreroot bppReRoot.cpp)
add_executable (bpptreedraw bppTreeDraw.cpp)
add_executable (bppalnscore bppAlnScore.cpp)
add_executable (bpppopstats bppPopStats.cpp)

set (bppsuite-targets
  bppml
  bppseqgen
  bppdist
  bpppars
  bppseqman
  bppconsense
  bppancestor
  bppmixedlikelihoods
  bppreroot
  bpptreedraw
  bppalnscore
  bpppopstats
  )

foreach (target ${bppsuite-targets})
  # Link (static or shared)
  if (BUILD_STATIC)
    target_link_libraries (${target} ${BPP_LIBS_STATIC})
    set_target_properties (${target} PROPERTIES LINK_SEARCH_END_STATIC TRUE)
  else (BUILD_STATIC)
    target_link_libraries (${target} ${BPP_LIBS_SHARED})
    set_target_properties (${target} PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
  endif (BUILD_STATIC)
endforeach (target)

install (TARGETS ${bppsuite-targets} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== man/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Authors:
#   Julien Dutheil
#   Francois gindraud (2017)
# Created: 22/08/2009

# Build manpages.
# In practice, they are just compressed from the text files using COMPRESS_PROGRAM
# Manpages are built and installed as part of "all" if a COMPRESS_PROGRAM is found.

# Take all manpages files in the directory
file (GLOB manpage_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.1)

if (NOT COMPRESS_BIN)
  # Just install manpages from source
  foreach (manpage_file ${manpage_files})
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/${manpage_file} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
  endforeach (manpage_file)
else ()
  # Create a list of manpage targets
  set (manpage-targets)

  foreach (manpage_file ${manpage_files})
    # Compress manpage, install, add to manpage target list
    set (input ${CMAKE_CURRENT_SOURCE_DIR}/${manpage_file})
    set (output ${CMAKE_CURRENT_BINARY_DIR}/${manpage_file}.${COMPRESS_EXT})
    add_custom_command (
      OUTPUT ${output}
      COMMAND ${COMPRESS_BIN} ${COMPRESS_ARGS} ${input} > ${output}
      DEPENDS ${input}
      COMMENT "Compressing manpage ${manpage_file}"
      VERBATIM
      )
    install (FILES ${output} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
    list (APPEND manpage-targets ${output})
    unset (input)
    unset (output)
  endforeach (manpage_file)

  # Add target "man", built with "all" (needed because install will fail if not built).
  add_custom_target (man ALL DEPENDS ${manpage-targets})
endif ()

=== debian/changelog ===
bppsuite (2.4.1-8) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Backport upstream fix for FTBFS with CMake 4. Closes: #1112733.

  [ Santiago Vila ]
  * d/control: Drop "Rules-Requires-Root: no" (default).
  * d/control: Update standards-version.
  * d/salsa-ci.yml: Use the simplified version.

 -- Santiago Vila <sanvila@debian.org>  Tue, 14 Oct 2025 02:20:00 +0200

bppsuite (2.4.1-7) unstable; urgency=medium

  * Team upload.
  * d/patches/hardening: Added patch to not shadow dpkg-buildflags
  * d/rules: specifying RelWithDebInfo isn't necessary for getting
    unstripped binaries.
  * d/patches/spelling: new patch to fix typos.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 25 Mar 2024 12:53:01 +0100

bppsuite (2.4.1-6) unstable; urgency=medium

  * Relax autopkgtest for arm64
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 10 Jan 2023 18:55:38 +0100

bppsuite (2.4.1-5) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 01 Nov 2022 19:54:28 +0100

bppsuite (2.4.1-4) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Exclude tag v3.0.0 to be considered a new version
    (see https://github.com/BioPP/bppsuite/issues/14#issuecomment-1041137412)
  * Standards-Version: 4.6.0 (routine-update)
  * Build-Depends: libeigen3-dev
  * Enable uscan to create a sensible download name

 -- Andreas Tille <tille@debian.org>  Wed, 16 Feb 2022 08:50:02 +0100

bppsuite (2.4.1-3) unstable; urgency=medium

  * Approximate autopkgtest output. Closes: #963088.
  * Add Pranav Ballaney to Uploaders

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Tue, 15 Sep 2020 18:56:51 +0530

bppsuite (2.4.1-2) unstable; urgency=medium

  * Team upload.

  [ Pranav Ballaney ]
  * Add reference data for autopkgtests
  * Install examples for bppsuite
  * Add autopkgtests
  * Install docs

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Refer to specific version of license GPL-2+.
  * Fix day-of-week for changelog entry 0.3.0.
  * Cleanup installation of manpages

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Fri, 12 Jun 2020 06:00:09 +0530

bppsuite (2.4.1-1) unstable; urgency=medium

  [ Julien Dutheil ]
  * New upstream version

  [ Andreas Tille ]
  * Standards-Version: 4.2.0

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Wed, 22 Aug 2018 09:18:13 +0200

=== debian/control ===
Source: bppsuite
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>,
           Andreas Tille <tille@debian.org>,
           Pranav Ballaney <ballaneypranav@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               texinfo,
               libbpp-phyl-dev,
               libbpp-popgen-dev,
               libeigen3-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/bppsuite
Vcs-Git: https://salsa.debian.org/med-team/bppsuite.git
Homepage: http://biopp.univ-montp2.fr/wiki/index.php/Main_Page

Package: bppsuite
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: bppsuite-examples
Description: Bio++ program suite
 The Bio++ Program Suite is a package of programs using the Bio++
 libraries and dedicated to Phylogenetics and Molecular Evolution.  All
 programs are independent, but can be combined to perform rather complex
 analyses.  These programs use the interface helper tools of the
 libraries, and hence share the same syntax.  They also have several
 options in common, which may also be shared by third-party software.
 .
 The following programs are included:
  - BppML for maximum likelihood analysis,
  - BppSeqGen for sequences simulation,
  - BppAncestor for ancestral states reconstruction,
  - BppDist for distance methods,
  - BppPars for parsimony analysis,
  - BppSeqMan for file conversion and sequence manipulation,
  - BppConsense for building consensus tree and computing
    bootstrap values,
  - BppReRoot for tree rerooting.
  - BppTreeDraw for tree drawing.
  - BppAlnScore for comparing alignments and computing alignment scores.
  - BppMixedLikelihoods for computing site per site likelihoods of
    components of mixture models.
  - BppPopGen for population genetics analyses.

Package: bppsuite-examples
Architecture: all
Depends: ${misc:Depends}
Enhances: bppsuite
Multi-Arch: foreign
Description: Examples for Bio++ program suite
 The Bio++ Program Suite is a package of programs using the Bio++
 libraries and dedicated to Phylogenetics and Molecular Evolution.  All
 programs are independent, but can be combined to perform rather complex
 analyses.  These programs use the interface helper tools of the
 libraries, and hence share the same syntax.  They also have several
 options in common, which may also be shared by third-party software.
 .
 This package contains some example data sets.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_after_dh_fixperms:
	find debian -name "*.dnd" -exec chmod -x \{\} \;

=== debian/watch ===
version=4

opts="uversionmangle=s/3.0.0/0.3.0.0/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/BioPP/bppsuite/tags .*/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
